/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <syslog.h>
#include <string.h>
#define XtNumber(x) sizeof(x)/sizeof(x[0])

#include "struct.h"

void *timer( void *a ) {

	workp works =(workp)a;
	static char CATbuf[50];
	int j, k;

	// continuous loop
	syslog( LOG_INFO, "Timer thread started" );
	prctl( PR_SET_NAME, (unsigned long)"Timer", 0, 0, 0 );

	for( j=0,k=25; works->unterminated ;j=1-j,++k,k%=50 ) {		
		
		usleep( works->setup->timeDelay/2 );
		if ( works->DrawTmate ) {
			works->DrawTmate( works );
		}
		usleep( works->setup->timeDelay/2 );
		if( works->serParms->ptt > 0 || works->serParms->tune > 0 ) {
			if( j==0 ) {
				memset( CATbuf, 0, XtNumber( CATbuf ) );
				sprintf( CATbuf, "FP;RP;" );
				sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
			}
		} else {
			sendWebSockHebFrame( works, NULL, 0 );
		}
		if( !k ) {
			if( works->countSo == works->countOldSo ) {
				// works->countTo=1;
			}
			works->countOldSo = works->countSo;
			if( works->setup->enableTmate == '1' ) {
				controltmate( works );
			} 
		} 
	}
	
	syslog( LOG_INFO, "Timer operations end\n" );
	pthread_exit( a );
	return( a );
}

